var EventEmitter = require("fast-event-emitter");

module.exports = function (app) {

  app.use(require("mojo-mediator"));

  var readyEmitter = new EventEmitter(),
  ready = false;

  readyEmitter.once("ready", function () {
    ready = true;
  });

  app.setProperties({
    bootstrap: function (options, complete) {

      if (typeof options === "function") {
        complete = options;
        options = {};
      }

      if (!complete) complete = function () {};
      
      app.ready(complete);
      app.initialize(options);
    },
    ready: function (callback) {
      if (ready) return callback();
      readyEmitter.once("ready", callback);
    }
  });

  app.once("initialize", function (options) {
    app.mediator.execute("bootstrap", options, function () {
      if (app.didBootstrap) {
        app.didBootstrap(options);
      }
      readyEmitter.emit("ready");
    });
  });

}